$ifndef _LargeArrays_
$define _LargeArrays_
'
' Large array handling macros for the proton compiler
' Written by Les Johnson 2010
'
' Not fully tested
.
$if (_core <> 16)
    $error "Large array macros are for 18F devices only"
$endif
'---------------------------------------------------------------------------------------
' Large Byte or Word Array Retrieve Macro
'
' Syntax:
'
' Retreive from a large Byte or Word Array
' Var = ReadArray Array Name , [Array Index]
'
ReadArray Macro- pArrayName, pArrayIndex, pValueToPlace \ Word
#if((Prm_2 == Float) || (Prm_2 == Fnum))
         #error "ReadArray macro index value cannot be a Floating Point Variable or Constant"
        Exitm
    #endif

#if ((Prm_1 != Byte_Array_Ptr) && (Prm_1 != Word_Array_Ptr))
    #error "Parameter 1 must be an Array's Name"
    Exitm
#endif

Asm-
    Lfsr 0,pArrayName
Endasm-
#if (Prm_1 == Word_Array_Ptr)               ' Is the Array a Word Array?
#if((Prm_2 == Num8) || (Prm_2 == Num16) || (Prm_2 == Num32))    ' Index is a Constant value
    #if (pArrayIndex > 0)
    Movlw ((pArrayIndex*2)&255)             ' Multiply index by two and extract the low byte
    Addwf FSR0L,f                           ' Add it to the value already held in FSR0L
    Movlw (((pArrayIndex*2)>>8)&255)        ' Multiply index by two and extract the high byte
    Addwfc FSR0H,f                          ' Add it to the value already held in FSR0H
    #endif
#endif

#if(Prm_2 == Byte)                          ' Index is a Byte Variable?
    #if(pArrayIndex != WREG)
Asm-
    Movff pArrayIndex,WREG
Endasm-
    #endif
    Bcf STATUS,0                            ' \ Multiply index by two (immune from bank changes)
    Rlf WREG,f                              ' /
    Addwf FSR0L,f                           ' \
    Movlw 0                                 '  | Add it to the value already held in FSR0L\H
    Addwfc FSR0LH,f                         ' /
#endif

#if((Prm_2 == Word) || (Prm_2 == Dword))    ' Index is a Word or Dword Variable?
Asm-
    Lfsr 1,pArrayIndex                      ' Load the index variable's address into FSR1
    Bcf STATUS,0                            ' \
    Rlcf POSTINC1,w                         '  |
    Movwf PRODL                             '  | Multiply index by two (immune from bank changes)
    Rlcf INDF1,w                            '  |
    Movwf PRODLH                            ' /
    Movf PRODL,w                            ' \
    Addwf FSR0L,f                           '  |
    Movf PRODH,w                            '  | Add it To the value already held in FSR0L\H
    Addwfc FSR0H,f                          ' /
Endasm-
#if (ReadArray_Return == 1)                ' Is there an assignment variable?
Asm-
    Movff POSTINC0,Return_Var
    Movff POSTINC0,Return_Var + 1
Endasm-
#endif
#endif
#else                                       ' A Byte Array
#if((Prm_2 == Num8) || (Prm_2 == Num16) || (Prm_2 == Num32))    ' Index is a Constant value
    #if (pArrayIndex > 0)
    Movlw (pArrayIndex&255)                 ' Extract index low byte
    Addwf FSR0L,f                           ' Add it to the value already held in FSR0L
    Movlw ((pArrayIndex>>8)&255)            ' Extract index high byte
    Addwfc FSR0H,f                          ' Add it to the value already held in FSR0H
    #endif
#endif

#if(Prm_2 == Byte)                          ' Index is a Byte Variable?
    #if(pArrayIndex != WREG)
Asm-
    Movff pArrayIndex,WREG                  ' Place index into WREG
Endasm-
    #endif
    Addwf FSR0L,f                           ' \
    Movlw 0                                 '  | Add it to the value already held in FSR0L\H
    Addwfc FSR0LH,f                         ' /
#endif

#if((Prm_2 == Word) || (Prm_2 == Dword))    ' Index is a Word or Dword Variable?
Asm-
    Lfsr 1,pArrayIndex                      ' Load the index variable's address into FSR1
    Movf POSTINC1,w                         ' \
    Addwf FSR0L,f                           '  |
    Movf INDF1,w                            '  | Add it To the value already held in FSR0L\H
    Addwfc FSR0H,f                          ' /
Endasm-
#endif
#if (ReadArray_Return == 1)                ' Is there an assignment variable?
Asm-
    Movff POSTINC0,Return_Var
    Movff POSTINC0,Return_Var + 1
Endasm-
#endif
#endif
    Endm

'---------------------------------------------------------------------------------------
' Large Byte or Word Array Load Macro
'
' Syntax:
'
' Load into a large Byte or Word Array
' WriteArray Array Name , [Array Index] , Var
'
WriteArray Macro- pArrayName, pArrayIndex, pValueToPlace \ Dword
#if ((Prm_1 != Byte_Array_Ptr) && (Prm_1 != Word_Array_Ptr))
    #error "Parameter 1 must be an Array's Name"
    Exitm
#endif
    #if((Prm_2 == Float) || (Prm_2 == Fnum))
         #error "WriteArray macro index value cannot be a Floating Point Variable or Constant"
        Exitm
    #endif
Asm-
    Lfsr 0,pArrayName
Endasm-
#if (Prm_1 == Word_Array_Ptr)               ' Is the Array a Word Array?
#if((Prm_2 == Num8) || (Prm_2 == Num16) || (Prm_2 == Num32))    ' Index is a Constant value
    #if (pArrayIndex > 0)
    Movlw ((pArrayIndex*2)&255)             ' Multiply index by two and extract the low byte
    Addwf FSR0L,f                           ' Add it to the value already held in FSR0L
    Movlw (((pArrayIndex*2)>>8)&255)        ' Multiply index by two and extract the high byte
    Addwfc FSR0H,f                          ' Add it to the value already held in FSR0H
    #endif
#endif

#if(Prm_2 == Byte)                          ' Index is a Byte Variable?
    #if(pArrayIndex != WREG)
Asm-
    Movff pArrayIndex,WREG
Endasm-
    #endif
    Bcf STATUS,0                            ' \ Multiply index by two (immune from bank changes)
    Rlf WREG,f                              ' /
    Addwf FSR0L,f                           ' \
    Movlw 0                                 '  | Add it to the value already held in FSR0L\H
    Addwfc FSR0LH,f                         ' /
#endif

#if((Prm_2 == Word) || (Prm_2 == Dword))    ' Index is a Word or Dword Variable?
Asm-
    Lfsr 1,pArrayIndex                      ' Load the index variable's address into FSR1
    Bcf STATUS,0                            ' \
    Rlcf POSTINC1,w                         '  |
    Movwf PRODL                             '  | Multiply index by two (immune from bank changes)
    Rlcf INDF1,w                            '  |
    Movwf PRODLH                            ' /
    Movf PRODL,w                            ' \
    Addwf FSR0L,f                           '  |
    Movf PRODH,w                            '  | Add it To the value already held in FSR0L\H
    Addwfc FSR0H,f                          ' /
Endasm-
#endif
    #if (Prm_Count != 3)
         #error "Missing Loading Operand with WriteArray macro"
    #else
    #if((Prm_3 == Num8) || (Prm_3 == Num16) || (Prm_3 == Num32) || (Prm_3 == SNum8) || (Prm_3 == SNum16) || (Prm_3 == SNum32))
        #if((pValueToPlace & 255) == 255)
            Setf POSTINC0
        #else
            #if((pValueToPlace & 255) == 0)                     ' Operate on low byte
                Clrf POSTINC0
            #else
                Num_SFR (pValueToPlace & 255),POSTINC0
            #endif
        #endif

        #if(((pValueToPlace >> 8) & 255) == 255)                ' Operate on high byte
            Setf POSTINC0
        #else
            #if(((pValueToPlace >> 8) & 255) == 0)
                Clrf POSTINC0
            #else
                Num_SFR ((pValueToPlace >> 8) & 255),POSTINC0
            #endif
        #endif
    #endif
    #if(Prm_3 == Byte)
        Asm-
        Movff pValueToPlace,POSTINC0
        Endasm-
        Clrf POSTINC0
    #endif
    #if(Prm_3 == Word)
        Asm-
        Movff pValueToPlace,POSTINC0
        Movff pValueToPlace + 1,POSTINC0
        Endasm-
    #endif
    #if((Prm_3 == Dword) || (Prm_3 == Float))
        Asm-
        Movff pValueToPlace,POSTINC0
        Movff pValueToPlace + 1,POSTINC0
        Endasm-
    #endif
    #endif
#else                                       ' A Byte Array
#if((Prm_2 == Num8) || (Prm_2 == Num16) || (Prm_2 == Num32))    ' Index is a Constant value
    #if (pArrayIndex > 0)
    Movlw (pArrayIndex&255)                 ' Extract index low byte
    Addwf FSR0L,f                           ' Add it to the value already held in FSR0L
    Movlw ((pArrayIndex>>8)&255)            ' Extract index high byte
    Addwfc FSR0H,f                          ' Add it to the value already held in FSR0H
    #endif
#endif

#if(Prm_2 == Byte)                          ' Index is a Byte Variable?
    #if(pArrayIndex != WREG)
Asm-
    Movff pArrayIndex,WREG                  ' Place index into WREG
Endasm-
    #endif
    Addwf FSR0L,f                           ' \
    Movlw 0                                 '  | Add it to the value already held in FSR0L\H
    Addwfc FSR0LH,f                         ' /
#endif

#if((Prm_2 == Word) || (Prm_2 == Dword))    ' Index is a Word or Dword Variable?
Asm-
    Lfsr 1,pArrayIndex                      ' Load the index variable's address into FSR1
    Movf POSTINC1,w                         ' \
    Addwf FSR0L,f                           '  |
    Movf INDF1,w                            '  | Add it To the value already held in FSR0L\H
    Addwfc FSR0H,f                          ' /
Endasm-
#endif
    #if (Prm_Count != 3)
         #error "Missing Loading Operand with WriteArray macro"
    #else
    #if((Prm_3 == Num8) || (Prm_3 == Num16) || (Prm_3 == Num32) || (Prm_3 == SNum8) || (Prm_3 == SNum16) || (Prm_3 == SNum32))
        #if((pValueToPlace & 255) == 255)
            Setf POSTINC0
        #else
            #if((pValueToPlace & 255) == 0)                     ' Operate on low byte
                Clrf POSTINC0
            #else
                Num_SFR (pValueToPlace & 255),POSTINC0
            #endif
        #endif
    #endif
    #if(Prm_3 == Byte)
    Asm-
        Movff pValueToPlace,POSTINC0
    Endasm-
    #endif
    #if(Prm_3 == Word)
        Asm-
        Movff pValueToPlace,POSTINC0
        Endasm-
    #endif
    #if((Prm_3 == Dword) || (Prm_3 == Float))
        Asm-
        Movff pValueToPlace,POSTINC0
        Endasm-
    #endif
    #endif
#endif
    Endm
$endif


